package Feeder::feeder;

use strict;

use Exporter;
use vars qw(@ISA @EXPORT);
@ISA = qw(Exporter);
@EXPORT = qw(&mkdirhier &parse_headers &parse_contents &updategroups &movepack);


use vars qw(%numery $MAINDIR $ARCHIVE $RECEIVED $GROUPS $archive
	$uncompr %params $paczka $ODP2RE $QP28bit $CP2ISO);


die unless (eval `cat /etc/feeder.conf`);
init();


=mkdirhier

mkdirhier <dir>

=cut

sub mkdirhier {
	my $dir;
#	print join ('-',@_), "\n";
	$dir="$_[0]";

	if (-d $dir) {return 1};

	$dir =~ m#^(.*)/(.*)# || $dir =~ m#()(.*)#;
	my ($path, $dir_name) = ($1, $2);# if (defined($2));;

#	print "||", "$dir = $path / $dir_name", "\n";
	if (-d "$path/" || mkdirhier ($path)) {
		return 1 if (mkdir $dir, 0755);
		die "Can't create directory $path/$dir_name: $!\n";
	}
}


sub init {
	$ARCHIVE	= "$MAINDIR/archive";
	$RECEIVED	= "$MAINDIR/received";
	$GROUPS		= "$MAINDIR/groups";
	my $compr	= $params{'compress'};


	mkdirhier "$RECEIVED";
	mkdirhier "$ARCHIVE" if ($archive eq "yes");

	open GROUPS, "$GROUPS" or die "Nie mog otworzy $GROUPS: $!";
	foreach (<GROUPS>) {
		/^\s*(.+)\s+(-?\d+)/;
		$numery{$1}=$2;
	}
	close GROUPS or warn "Nie mog zamkn $GROUPS: $!";

	if ($compr eq 'bzip2') {$paczka = "$RECEIVED/paczka.bz2"; $uncompr = "bunzip2 -c $paczka |";}
	elsif ($compr eq 'gzip') {$paczka = "$RECEIVED/paczka.gz"; $uncompr = "gunzip -c $paczka |";}
	elsif ($compr eq 'zip') {$paczka = "$RECEIVED/paczka.zip"; $uncompr = "unzip -p $paczka |";}
	else {$paczka = "$RECEIVED/paczka.txt"; $uncompr = $paczka;}
}


=parse_headers

parse_headers <\$headers>

=cut

sub parse_headers {
	my $val=0;
	${$_[0]} =~ s/^Subject: (Re: |Odp: )+/Subject: Re: /im if ($ODP2RE eq "yes");
	if ($QP28bit eq "yes") {
		$val=1 if (${$_[0]} =~ /^Content-Transfer-Encoding: (?i:quoted-printable)$/m);
		${$_[0]} =~ s/^(Content-Transfer-Encoding: )(?i:quoted-printable|7bit)$/${1}8bit/m;
	}
	return $val;
}


=parse_contents

parse_contents <\$contents> <$quoted> <$CP2ISO>

=cut

sub parse_contents {
	if ($_[1]) {
		s/=([\dA-F]{2})/chr hex $1/ge;
		s/=\n//g;
	}
	${$_[0]} =~ tr/// if ($CP2ISO eq "yes");
}


=updategroups

updategroups

=cut

sub updategroups {
	print "Updating file $GROUPS\n";
	open GROUPS, ">$GROUPS" or die "Can't create file $GROUPS: $!\n" and return;
	print GROUPS "$_ $numery{$_}\n" foreach (keys(%numery));
	close GROUPS or warn "Can't close file $GROUPS: $!\n";
}


=movepack

movepack <$archive> <$paczka>

=cut

sub movepack {
	return unless -f "$paczka";
	if ($archive eq "yes") {
		my $date=localtime((stat($paczka))[9]);
		$date =~ s/\s/_/g;
		$paczka =~ /.*(\..*?)$/;
		link "$paczka", "$ARCHIVE/pack-$date$1" || die "Can't link $paczka to $ARCHIVE/pack-$date$1\n";
	}
	unlink "$paczka";
}


1;
